/*
 * LR0ItemsLabel.cpp
 *
 *  Created on: 29. 4. 2016
 *      Author: Martin Kocicka
 */

#include "LR0ItemsLabel.h"
#include <label/Label.h>
#include <object/Object.h>

#include <container/ObjectsMap.h>
#include <container/ObjectsSet.h>
#include <container/ObjectsVector.h>
#include <primitive/Unsigned.h>

#include <container/xml/ObjectsMap.h>
#include <container/xml/ObjectsSet.h>
#include <container/xml/ObjectsVector.h>
#include <container/xml/ObjectsVariant.h>
#include <primitive/xml/Unsigned.h>

#include <registration/XmlRegistration.hpp>

namespace core {

label::LR0ItemsLabel xmlApi < label::LR0ItemsLabel >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName() );
	label::LR0ItemsLabel data ( core::xmlApi < grammar::parsing::LR0Items > ::parse ( input ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName() );
	return data;
}

bool xmlApi < label::LR0ItemsLabel >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < label::LR0ItemsLabel >::xmlTagName ( ) {
	static std::string xmlTagName = "LR0ItemsLabel";

	return xmlTagName;
}

void xmlApi < label::LR0ItemsLabel >::compose ( ext::deque < sax::Token > & output, const label::LR0ItemsLabel & label ) {
	output.emplace_back ( xmlTagName(), sax::Token::TokenType::START_ELEMENT );
	core::xmlApi < grammar::parsing::LR0Items > ::compose ( output, label.getItems ( ) );
	output.emplace_back ( xmlTagName(), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < label::LR0ItemsLabel > ( );
static auto xmlRead = registration::XmlReaderRegister < label::LR0ItemsLabel > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < label::Label, label::LR0ItemsLabel > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, label::LR0ItemsLabel > ( );

} /* namespace */
